/* bookmarks.c generated by valac 0.41.91, the Vala compiler
 * generated from bookmarks.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <https://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define TYPE_BOOKMARKS (bookmarks_get_type ())
#define BOOKMARKS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOKMARKS, Bookmarks))
#define BOOKMARKS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOKMARKS, BookmarksClass))
#define IS_BOOKMARKS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOKMARKS))
#define IS_BOOKMARKS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOKMARKS))
#define BOOKMARKS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOKMARKS, BookmarksClass))

typedef struct _Bookmarks Bookmarks;
typedef struct _BookmarksClass BookmarksClass;
typedef struct _BookmarksPrivate BookmarksPrivate;
enum  {
	BOOKMARKS_0_PROPERTY,
	BOOKMARKS_SCHEMA_PATH_PROPERTY,
	BOOKMARKS_NUM_PROPERTIES
};
static GParamSpec* bookmarks_properties[BOOKMARKS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_VIEW_TYPE (view_type_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define TYPE_BOOKMARK (bookmark_get_type ())
#define BOOKMARK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOKMARK, Bookmark))
#define BOOKMARK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOKMARK, BookmarkClass))
#define IS_BOOKMARK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOKMARK))
#define IS_BOOKMARK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOKMARK))
#define BOOKMARK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOKMARK, BookmarkClass))

typedef struct _Bookmark Bookmark;
typedef struct _BookmarkClass BookmarkClass;
typedef struct _Block1Data Block1Data;
typedef struct _BookmarkPrivate BookmarkPrivate;
enum  {
	BOOKMARK_0_PROPERTY,
	BOOKMARK_NUM_PROPERTIES
};
static GParamSpec* bookmark_properties[BOOKMARK_NUM_PROPERTIES];
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Bookmarks {
	GtkMenuButton parent_instance;
	BookmarksPrivate * priv;
};

struct _BookmarksClass {
	GtkMenuButtonClass parent_class;
};

struct _BookmarksPrivate {
	GtkListBox* bookmarks_list_box;
	GtkPopover* bookmarks_popover;
	GtkImage* bookmarks_icon;
	GtkSwitch* bookmarked_switch;
	gchar* current_path;
	gchar* schema_id;
	gchar* _schema_path;
	GSettings* settings;
};

typedef enum  {
	VIEW_TYPE_OBJECT,
	VIEW_TYPE_FOLDER,
	VIEW_TYPE_SEARCH
} ViewType;

struct _Block1Data {
	int _ref_count_;
	Bookmarks* self;
	gulong bookmarks_changed_handler;
	gulong clicked_handler;
};

struct _Bookmark {
	GtkListBoxRow parent_instance;
	BookmarkPrivate * priv;
};

struct _BookmarkClass {
	GtkListBoxRowClass parent_class;
};

struct _BookmarkPrivate {
	GtkLabel* bookmark_label;
	GtkButton* destroy_button;
};


static gint Bookmarks_private_offset;
static gpointer bookmarks_parent_class = NULL;
static gint Bookmark_private_offset;
static gpointer bookmark_parent_class = NULL;

GType bookmarks_get_type (void) G_GNUC_CONST;
static void bookmarks_bookmark (Bookmarks* self,
                         GSimpleAction* action,
                         GVariant* path_variant);
static void _bookmarks_bookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self);
static void bookmarks_unbookmark (Bookmarks* self,
                           GSimpleAction* action,
                           GVariant* path_variant);
static void _bookmarks_unbookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self);
GType view_type_get_type (void) G_GNUC_CONST;
void bookmarks_set_path (Bookmarks* self,
                         ViewType type,
                         const gchar* path);
static void bookmarks_update_icon_and_switch (Bookmarks* self);
gchar** bookmarks_get_bookmarks (Bookmarks* self,
                                 int* result_length1);
void bookmarks_set_bookmarked (Bookmarks* self,
                               const gchar* path,
                               gboolean new_state);
static void bookmarks_append_bookmark (Bookmarks* self,
                                const gchar* path);
static void bookmarks_remove_bookmark (Bookmarks* self,
                                const gchar* bookmark_name);
static void bookmarks_install_action_entries (Bookmarks* self);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      gchar* needle);
static void bookmarks_update_switch (Bookmarks* self,
                              gboolean bookmarked);
static void bookmarks_update_bookmarks (Bookmarks* self);
static void __lambda4_ (Bookmarks* self,
                 GtkWidget* widget);
static void ___lambda4__gtk_callback (GtkWidget* widget,
                               gpointer self);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
GType bookmark_get_type (void) G_GNUC_CONST;
Bookmark* bookmark_new (const gchar* bookmark_name);
Bookmark* bookmark_construct (GType object_type,
                              const gchar* bookmark_name);
gboolean settings_model_is_key_path (const gchar* path);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
Bookmarks* bookmarks_new (void);
Bookmarks* bookmarks_construct (GType object_type);
static const gchar* bookmarks_get_schema_path (Bookmarks* self);
static void bookmarks_set_schema_path (Bookmarks* self,
                                const gchar* value);
static GObject * bookmarks_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _bookmarks___lambda95_ (Bookmarks* self);
static void __bookmarks___lambda95__g_settings_changed (GSettings* _sender,
                                                 const gchar* key,
                                                 gpointer self);
static void _bookmarks___lambda96_ (Bookmarks* self);
static void __bookmarks___lambda96__gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self);
static void _bookmarks___lambda97_ (Block1Data* _data1_);
static void __bookmarks___lambda97__gtk_widget_destroy (GtkWidget* _sender,
                                                 gpointer self);
static void bookmarks_finalize (GObject * obj);
static void _vala_bookmarks_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_bookmarks_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static void bookmark_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const GActionEntry BOOKMARKS_action_entries[2] = {{"bookmark", _bookmarks_bookmark_gsimple_action_activate_callback, "s"}, {"unbookmark", _bookmarks_unbookmark_gsimple_action_activate_callback, "s"}};

static inline gpointer
bookmarks_get_instance_private (Bookmarks* self)
{
	return G_STRUCT_MEMBER_P (self, Bookmarks_private_offset);
}


static void
_bookmarks_bookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                      GVariant* parameter,
                                                      gpointer self)
{
	bookmarks_bookmark ((Bookmarks*) self, action, parameter);
}


static void
_bookmarks_unbookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                        GVariant* parameter,
                                                        gpointer self)
{
	bookmarks_unbookmark ((Bookmarks*) self, action, parameter);
}


void
bookmarks_set_path (Bookmarks* self,
                    ViewType type,
                    const gchar* path)
{
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	if (type == VIEW_TYPE_SEARCH) {
		return;
	}
	_tmp0_ = self->priv->current_path;
	if (g_strcmp0 (_tmp0_, path) != 0) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (path);
		_g_free0 (self->priv->current_path);
		self->priv->current_path = _tmp1_;
	}
	bookmarks_update_icon_and_switch (self);
}


gchar**
bookmarks_get_bookmarks (Bookmarks* self,
                         int* result_length1)
{
	gchar** result = NULL;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->settings;
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "bookmarks");
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _vala_array_length (_tmp1_);
	if (result_length1) {
		*result_length1 = _tmp3__length1;
	}
	result = _tmp3_;
	return result;
}


void
bookmarks_set_bookmarked (Bookmarks* self,
                          const gchar* path,
                          gboolean new_state)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp1_ = self->priv->current_path;
	if (g_strcmp0 (path, _tmp1_) == 0) {
		GtkSwitch* _tmp2_;
		_tmp2_ = self->priv->bookmarked_switch;
		_tmp0_ = gtk_switch_get_active (_tmp2_) == new_state;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	if (new_state) {
		bookmarks_append_bookmark (self, path);
	} else {
		bookmarks_remove_bookmark (self, path);
	}
}


static void
bookmarks_install_action_entries (Bookmarks* self)
{
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_simple_action_group_new ();
	action_group = _tmp0_;
	g_action_map_add_action_entries ((GActionMap*) action_group, BOOKMARKS_action_entries, G_N_ELEMENTS (BOOKMARKS_action_entries), self);
	gtk_widget_insert_action_group ((GtkWidget*) self, "bookmarks", (GActionGroup*) action_group);
	_g_object_unref0 (action_group);
}


static void
bookmarks_bookmark (Bookmarks* self,
                    GSimpleAction* action,
                    GVariant* path_variant)
{
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_vala_return_if_fail (path_variant != NULL, "path_variant != null");
	_tmp0_ = g_variant_get_string ((GVariant*) path_variant, NULL);
	bookmarks_append_bookmark (self, _tmp0_);
}


static void
bookmarks_unbookmark (Bookmarks* self,
                      GSimpleAction* action,
                      GVariant* path_variant)
{
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_vala_return_if_fail (path_variant != NULL, "path_variant != null");
	_tmp0_ = g_variant_get_string ((GVariant*) path_variant, NULL);
	bookmarks_remove_bookmark (self, _tmp0_);
}


static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             gchar* needle)
{
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


static void
bookmarks_update_icon_and_switch (Bookmarks* self)
{
	GVariant* variant = NULL;
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	const gchar* _tmp2_;
	GSettings* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->current_path;
	_tmp1_ = g_variant_new_string (_tmp0_);
	g_variant_ref_sink (_tmp1_);
	variant = _tmp1_;
	_tmp2_ = self->priv->current_path;
	_tmp3_ = self->priv->settings;
	_tmp5_ = _tmp4_ = g_settings_get_strv (_tmp3_, "bookmarks");
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _vala_array_length (_tmp4_);
	_tmp7_ = _vala_string_array_contains (_tmp6_, _vala_array_length (_tmp4_), _tmp2_);
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
	if (_tmp7_) {
		GtkImage* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gboolean _tmp12_;
		GtkSwitch* _tmp14_;
		GVariant* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		_tmp8_ = self->priv->bookmarks_icon;
		g_object_get (_tmp8_, "icon-name", &_tmp9_, NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = _tmp10_;
		_tmp12_ = g_strcmp0 (_tmp11_, "starred-symbolic") != 0;
		_g_free0 (_tmp11_);
		if (_tmp12_) {
			GtkImage* _tmp13_;
			_tmp13_ = self->priv->bookmarks_icon;
			g_object_set (_tmp13_, "icon-name", "starred-symbolic", NULL);
		}
		bookmarks_update_switch (self, TRUE);
		_tmp14_ = self->priv->bookmarked_switch;
		_tmp15_ = variant;
		_tmp16_ = g_variant_print (_tmp15_, FALSE);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strconcat ("bookmarks.unbookmark(", _tmp17_, NULL);
		_tmp19_ = _tmp18_;
		_tmp20_ = g_strconcat (_tmp19_, ")", NULL);
		_tmp21_ = _tmp20_;
		gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp14_, _tmp21_);
		_g_free0 (_tmp21_);
		_g_free0 (_tmp19_);
		_g_free0 (_tmp17_);
	} else {
		GtkImage* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gboolean _tmp26_;
		GtkSwitch* _tmp28_;
		GVariant* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		_tmp22_ = self->priv->bookmarks_icon;
		g_object_get (_tmp22_, "icon-name", &_tmp23_, NULL);
		_tmp24_ = _tmp23_;
		_tmp25_ = _tmp24_;
		_tmp26_ = g_strcmp0 (_tmp25_, "non-starred-symbolic") != 0;
		_g_free0 (_tmp25_);
		if (_tmp26_) {
			GtkImage* _tmp27_;
			_tmp27_ = self->priv->bookmarks_icon;
			g_object_set (_tmp27_, "icon-name", "non-starred-symbolic", NULL);
		}
		bookmarks_update_switch (self, FALSE);
		_tmp28_ = self->priv->bookmarked_switch;
		_tmp29_ = variant;
		_tmp30_ = g_variant_print (_tmp29_, FALSE);
		_tmp31_ = _tmp30_;
		_tmp32_ = g_strconcat ("bookmarks.bookmark(", _tmp31_, NULL);
		_tmp33_ = _tmp32_;
		_tmp34_ = g_strconcat (_tmp33_, ")", NULL);
		_tmp35_ = _tmp34_;
		gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp28_, _tmp35_);
		_g_free0 (_tmp35_);
		_g_free0 (_tmp33_);
		_g_free0 (_tmp31_);
	}
	_g_variant_unref0 (variant);
}


static void
bookmarks_update_switch (Bookmarks* self,
                         gboolean bookmarked)
{
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkSwitch* _tmp3_;
	GtkSwitch* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->bookmarked_switch;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (bookmarked == _tmp2_) {
		return;
	}
	_tmp3_ = self->priv->bookmarked_switch;
	gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp3_, "ui.empty('')");
	_tmp4_ = self->priv->bookmarked_switch;
	gtk_switch_set_active (_tmp4_, bookmarked);
}


static void
__lambda4_ (Bookmarks* self,
            GtkWidget* widget)
{
	g_return_if_fail (widget != NULL);
	gtk_widget_destroy (widget);
}


static void
___lambda4__gtk_callback (GtkWidget* widget,
                          gpointer self)
{
	__lambda4_ ((Bookmarks*) self, widget);
}


static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
bookmarks_update_bookmarks (Bookmarks* self)
{
	GtkListBox* _tmp0_;
	gchar** bookmarks = NULL;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint bookmarks_length1;
	gint _bookmarks_size_;
	gchar** unduplicated_bookmarks = NULL;
	gchar** _tmp4_;
	gint unduplicated_bookmarks_length1;
	gint _unduplicated_bookmarks_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GtkListBoxRow* first_row = NULL;
	GtkListBox* _tmp38_;
	GtkListBoxRow* _tmp39_;
	GtkListBoxRow* _tmp40_;
	GtkListBoxRow* _tmp41_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->bookmarks_list_box;
	gtk_container_foreach ((GtkContainer*) _tmp0_, ___lambda4__gtk_callback, self);
	_tmp1_ = self->priv->settings;
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "bookmarks");
	bookmarks = _tmp3_;
	bookmarks_length1 = _vala_array_length (_tmp2_);
	_bookmarks_size_ = bookmarks_length1;
	_tmp4_ = g_new0 (gchar*, 0 + 1);
	unduplicated_bookmarks = _tmp4_;
	unduplicated_bookmarks_length1 = 0;
	_unduplicated_bookmarks_size_ = unduplicated_bookmarks_length1;
	_tmp5_ = bookmarks;
	_tmp5__length1 = bookmarks_length1;
	{
		gchar** bookmark_collection = NULL;
		gint bookmark_collection_length1 = 0;
		gint _bookmark_collection_size_ = 0;
		gint bookmark_it = 0;
		bookmark_collection = _tmp5_;
		bookmark_collection_length1 = _tmp5__length1;
		for (bookmark_it = 0; bookmark_it < _tmp5__length1; bookmark_it = bookmark_it + 1) {
			gchar* _tmp6_;
			gchar* bookmark = NULL;
			_tmp6_ = g_strdup (bookmark_collection[bookmark_it]);
			bookmark = _tmp6_;
			{
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gint _tmp8__length1;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				Bookmark* bookmark_row = NULL;
				const gchar* _tmp12_;
				Bookmark* _tmp13_;
				const gchar* _tmp14_;
				Bookmark* _tmp35_;
				GtkListBox* _tmp36_;
				Bookmark* _tmp37_;
				_tmp7_ = bookmark;
				_tmp8_ = unduplicated_bookmarks;
				_tmp8__length1 = unduplicated_bookmarks_length1;
				if (_vala_string_array_contains (_tmp8_, _tmp8__length1, _tmp7_)) {
					_g_free0 (bookmark);
					continue;
				}
				_tmp9_ = unduplicated_bookmarks;
				_tmp9__length1 = unduplicated_bookmarks_length1;
				_tmp10_ = bookmark;
				_tmp11_ = g_strdup (_tmp10_);
				_vala_array_add1 (&unduplicated_bookmarks, &unduplicated_bookmarks_length1, &_unduplicated_bookmarks_size_, _tmp11_);
				_tmp12_ = bookmark;
				_tmp13_ = bookmark_new (_tmp12_);
				g_object_ref_sink (_tmp13_);
				bookmark_row = _tmp13_;
				_tmp14_ = bookmark;
				if (settings_model_is_key_path (_tmp14_)) {
					GVariant* variant = NULL;
					const gchar* _tmp15_;
					GVariant* _tmp16_;
					Bookmark* _tmp17_;
					GVariant* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					_tmp15_ = bookmark;
					_tmp16_ = g_variant_new ("(ss)", _tmp15_, "", NULL);
					g_variant_ref_sink (_tmp16_);
					variant = _tmp16_;
					_tmp17_ = bookmark_row;
					_tmp18_ = variant;
					_tmp19_ = g_variant_print (_tmp18_, FALSE);
					_tmp20_ = _tmp19_;
					_tmp21_ = g_strconcat ("ui.open-object(", _tmp20_, NULL);
					_tmp22_ = _tmp21_;
					_tmp23_ = g_strconcat (_tmp22_, ")", NULL);
					_tmp24_ = _tmp23_;
					gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp17_, _tmp24_);
					_g_free0 (_tmp24_);
					_g_free0 (_tmp22_);
					_g_free0 (_tmp20_);
					_g_variant_unref0 (variant);
				} else {
					GVariant* variant = NULL;
					const gchar* _tmp25_;
					GVariant* _tmp26_;
					Bookmark* _tmp27_;
					GVariant* _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
					_tmp25_ = bookmark;
					_tmp26_ = g_variant_new_string (_tmp25_);
					g_variant_ref_sink (_tmp26_);
					variant = _tmp26_;
					_tmp27_ = bookmark_row;
					_tmp28_ = variant;
					_tmp29_ = g_variant_print (_tmp28_, FALSE);
					_tmp30_ = _tmp29_;
					_tmp31_ = g_strconcat ("ui.open-folder(", _tmp30_, NULL);
					_tmp32_ = _tmp31_;
					_tmp33_ = g_strconcat (_tmp32_, ")", NULL);
					_tmp34_ = _tmp33_;
					gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp27_, _tmp34_);
					_g_free0 (_tmp34_);
					_g_free0 (_tmp32_);
					_g_free0 (_tmp30_);
					_g_variant_unref0 (variant);
				}
				_tmp35_ = bookmark_row;
				gtk_widget_show ((GtkWidget*) _tmp35_);
				_tmp36_ = self->priv->bookmarks_list_box;
				_tmp37_ = bookmark_row;
				gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
				_g_object_unref0 (bookmark_row);
				_g_free0 (bookmark);
			}
		}
	}
	_tmp38_ = self->priv->bookmarks_list_box;
	_tmp39_ = gtk_list_box_get_row_at_index (_tmp38_, 0);
	_tmp40_ = _g_object_ref0 (_tmp39_);
	first_row = _tmp40_;
	_tmp41_ = first_row;
	if (_tmp41_ != NULL) {
		GtkListBox* _tmp42_;
		GtkListBoxRow* _tmp43_;
		_tmp42_ = self->priv->bookmarks_list_box;
		_tmp43_ = first_row;
		gtk_list_box_select_row (_tmp42_, G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_list_box_row_get_type (), GtkListBoxRow));
	}
	_g_object_unref0 (first_row);
	unduplicated_bookmarks = (_vala_array_free (unduplicated_bookmarks, unduplicated_bookmarks_length1, (GDestroyNotify) g_free), NULL);
	bookmarks = (_vala_array_free (bookmarks, bookmarks_length1, (GDestroyNotify) g_free), NULL);
}


static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void
bookmarks_append_bookmark (Bookmarks* self,
                           const gchar* path)
{
	GtkPopover* _tmp0_;
	gchar** bookmarks = NULL;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint bookmarks_length1;
	gint _bookmarks_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = self->priv->bookmarks_popover;
	g_signal_emit_by_name (_tmp0_, "closed");
	_tmp1_ = self->priv->settings;
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "bookmarks");
	bookmarks = _tmp3_;
	bookmarks_length1 = _vala_array_length (_tmp2_);
	_bookmarks_size_ = bookmarks_length1;
	_tmp4_ = bookmarks;
	_tmp4__length1 = bookmarks_length1;
	if (!_vala_string_array_contains (_tmp4_, _tmp4__length1, path)) {
		gchar** _tmp5_;
		gint _tmp5__length1;
		gchar* _tmp6_;
		GSettings* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		_tmp5_ = bookmarks;
		_tmp5__length1 = bookmarks_length1;
		_tmp6_ = g_strdup (path);
		_vala_array_add2 (&bookmarks, &bookmarks_length1, &_bookmarks_size_, _tmp6_);
		_tmp7_ = self->priv->settings;
		_tmp8_ = bookmarks;
		_tmp8__length1 = bookmarks_length1;
		g_settings_set_strv (_tmp7_, "bookmarks", _tmp8_);
	}
	bookmarks = (_vala_array_free (bookmarks, bookmarks_length1, (GDestroyNotify) g_free), NULL);
}


static void
_vala_array_add3 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void
bookmarks_remove_bookmark (Bookmarks* self,
                           const gchar* bookmark_name)
{
	GtkPopover* _tmp0_;
	gchar** old_bookmarks = NULL;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint old_bookmarks_length1;
	gint _old_bookmarks_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** new_bookmarks = NULL;
	gchar** _tmp5_;
	gint new_bookmarks_length1;
	gint _new_bookmarks_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GSettings* _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (bookmark_name != NULL);
	_tmp0_ = self->priv->bookmarks_popover;
	g_signal_emit_by_name (_tmp0_, "closed");
	_tmp1_ = self->priv->settings;
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "bookmarks");
	old_bookmarks = _tmp3_;
	old_bookmarks_length1 = _vala_array_length (_tmp2_);
	_old_bookmarks_size_ = old_bookmarks_length1;
	_tmp4_ = old_bookmarks;
	_tmp4__length1 = old_bookmarks_length1;
	if (!_vala_string_array_contains (_tmp4_, _tmp4__length1, bookmark_name)) {
		old_bookmarks = (_vala_array_free (old_bookmarks, old_bookmarks_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	_tmp5_ = g_new0 (gchar*, 0 + 1);
	new_bookmarks = _tmp5_;
	new_bookmarks_length1 = 0;
	_new_bookmarks_size_ = new_bookmarks_length1;
	_tmp6_ = old_bookmarks;
	_tmp6__length1 = old_bookmarks_length1;
	{
		gchar** bookmark_collection = NULL;
		gint bookmark_collection_length1 = 0;
		gint _bookmark_collection_size_ = 0;
		gint bookmark_it = 0;
		bookmark_collection = _tmp6_;
		bookmark_collection_length1 = _tmp6__length1;
		for (bookmark_it = 0; bookmark_it < _tmp6__length1; bookmark_it = bookmark_it + 1) {
			gchar* _tmp7_;
			gchar* bookmark = NULL;
			_tmp7_ = g_strdup (bookmark_collection[bookmark_it]);
			bookmark = _tmp7_;
			{
				gboolean _tmp8_ = FALSE;
				const gchar* _tmp9_;
				_tmp9_ = bookmark;
				if (g_strcmp0 (_tmp9_, bookmark_name) != 0) {
					const gchar* _tmp10_;
					gchar** _tmp11_;
					gint _tmp11__length1;
					_tmp10_ = bookmark;
					_tmp11_ = new_bookmarks;
					_tmp11__length1 = new_bookmarks_length1;
					_tmp8_ = !_vala_string_array_contains (_tmp11_, _tmp11__length1, _tmp10_);
				} else {
					_tmp8_ = FALSE;
				}
				if (_tmp8_) {
					gchar** _tmp12_;
					gint _tmp12__length1;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					_tmp12_ = new_bookmarks;
					_tmp12__length1 = new_bookmarks_length1;
					_tmp13_ = bookmark;
					_tmp14_ = g_strdup (_tmp13_);
					_vala_array_add3 (&new_bookmarks, &new_bookmarks_length1, &_new_bookmarks_size_, _tmp14_);
				}
				_g_free0 (bookmark);
			}
		}
	}
	_tmp15_ = self->priv->settings;
	_tmp16_ = new_bookmarks;
	_tmp16__length1 = new_bookmarks_length1;
	g_settings_set_strv (_tmp15_, "bookmarks", _tmp16_);
	new_bookmarks = (_vala_array_free (new_bookmarks, new_bookmarks_length1, (GDestroyNotify) g_free), NULL);
	old_bookmarks = (_vala_array_free (old_bookmarks, old_bookmarks_length1, (GDestroyNotify) g_free), NULL);
}


Bookmarks*
bookmarks_construct (GType object_type)
{
	Bookmarks * self = NULL;
	self = (Bookmarks*) g_object_new (object_type, NULL);
	return self;
}


Bookmarks*
bookmarks_new (void)
{
	return bookmarks_construct (TYPE_BOOKMARKS);
}


static const gchar*
bookmarks_get_schema_path (Bookmarks* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_schema_path;
	result = _tmp0_;
	return result;
}


static void
bookmarks_set_schema_path (Bookmarks* self,
                           const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, bookmarks_get_schema_path (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_schema_path);
		self->priv->_schema_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, bookmarks_properties[BOOKMARKS_SCHEMA_PATH_PROPERTY]);
	}
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		Bookmarks* self;
		self = _data1_->self;
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static void
_bookmarks___lambda95_ (Bookmarks* self)
{
	bookmarks_update_bookmarks (self);
	bookmarks_update_icon_and_switch (self);
}


static void
__bookmarks___lambda95__g_settings_changed (GSettings* _sender,
                                            const gchar* key,
                                            gpointer self)
{
	_bookmarks___lambda95_ ((Bookmarks*) self);
}


static void
_bookmarks___lambda96_ (Bookmarks* self)
{
	GtkSwitch* _tmp0_;
	_tmp0_ = self->priv->bookmarked_switch;
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
}


static void
__bookmarks___lambda96__gtk_button_clicked (GtkButton* _sender,
                                            gpointer self)
{
	_bookmarks___lambda96_ ((Bookmarks*) self);
}


static void
_bookmarks___lambda97_ (Block1Data* _data1_)
{
	Bookmarks* self;
	GSettings* _tmp0_;
	gulong _tmp1_;
	gulong _tmp2_;
	self = _data1_->self;
	_tmp0_ = self->priv->settings;
	_tmp1_ = _data1_->bookmarks_changed_handler;
	g_signal_handler_disconnect ((GObject*) _tmp0_, _tmp1_);
	_tmp2_ = _data1_->clicked_handler;
	g_signal_handler_disconnect ((GObject*) self, _tmp2_);
}


static void
__bookmarks___lambda97__gtk_widget_destroy (GtkWidget* _sender,
                                            gpointer self)
{
	_bookmarks___lambda97_ (self);
}


static GObject *
bookmarks_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Bookmarks * self;
	Block1Data* _data1_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	gulong _tmp4_;
	gulong _tmp5_;
	parent_class = G_OBJECT_CLASS (bookmarks_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOKMARKS, Bookmarks);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	bookmarks_install_action_entries (self);
	_tmp0_ = self->priv->schema_id;
	_tmp1_ = self->priv->_schema_path;
	_tmp2_ = g_settings_new_with_path (_tmp0_, _tmp1_);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp2_;
	_tmp3_ = self->priv->settings;
	_tmp4_ = g_signal_connect_object (_tmp3_, "changed::bookmarks", (GCallback) __bookmarks___lambda95__g_settings_changed, self, 0);
	_data1_->bookmarks_changed_handler = _tmp4_;
	bookmarks_update_bookmarks (self);
	_tmp5_ = g_signal_connect_object ((GtkButton*) self, "clicked", (GCallback) __bookmarks___lambda96__gtk_button_clicked, self, 0);
	_data1_->clicked_handler = _tmp5_;
	g_signal_connect_data ((GtkWidget*) self, "destroy", (GCallback) __bookmarks___lambda97__gtk_widget_destroy, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return obj;
}


static void
bookmarks_class_init (BookmarksClass * klass)
{
	bookmarks_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Bookmarks_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_bookmarks_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_bookmarks_set_property;
	G_OBJECT_CLASS (klass)->constructor = bookmarks_constructor;
	G_OBJECT_CLASS (klass)->finalize = bookmarks_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOKMARKS_SCHEMA_PATH_PROPERTY, bookmarks_properties[BOOKMARKS_SCHEMA_PATH_PROPERTY] = g_param_spec_string ("schema-path", "schema-path", "schema-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/bookmarks.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmarks_list_box", FALSE, Bookmarks_private_offset + G_STRUCT_OFFSET (BookmarksPrivate, bookmarks_list_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmarks_popover", FALSE, Bookmarks_private_offset + G_STRUCT_OFFSET (BookmarksPrivate, bookmarks_popover));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmarks_icon", FALSE, Bookmarks_private_offset + G_STRUCT_OFFSET (BookmarksPrivate, bookmarks_icon));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmarked_switch", FALSE, Bookmarks_private_offset + G_STRUCT_OFFSET (BookmarksPrivate, bookmarked_switch));
}


static void
bookmarks_instance_init (Bookmarks * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	self->priv = bookmarks_get_instance_private (self);
	_tmp0_ = g_strdup ("/");
	self->priv->current_path = _tmp0_;
	_tmp1_ = g_strdup ("ca.desrt.dconf-editor.Bookmarks");
	self->priv->schema_id = _tmp1_;
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void
bookmarks_finalize (GObject * obj)
{
	Bookmarks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOKMARKS, Bookmarks);
	_g_object_unref0 (self->priv->bookmarks_list_box);
	_g_object_unref0 (self->priv->bookmarks_popover);
	_g_object_unref0 (self->priv->bookmarks_icon);
	_g_object_unref0 (self->priv->bookmarked_switch);
	_g_free0 (self->priv->current_path);
	_g_free0 (self->priv->schema_id);
	_g_free0 (self->priv->_schema_path);
	_g_object_unref0 (self->priv->settings);
	G_OBJECT_CLASS (bookmarks_parent_class)->finalize (obj);
}


GType
bookmarks_get_type (void)
{
	static volatile gsize bookmarks_type_id__volatile = 0;
	if (g_once_init_enter (&bookmarks_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BookmarksClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bookmarks_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bookmarks), 0, (GInstanceInitFunc) bookmarks_instance_init, NULL };
		GType bookmarks_type_id;
		bookmarks_type_id = g_type_register_static (gtk_menu_button_get_type (), "Bookmarks", &g_define_type_info, 0);
		Bookmarks_private_offset = g_type_add_instance_private (bookmarks_type_id, sizeof (BookmarksPrivate));
		g_once_init_leave (&bookmarks_type_id__volatile, bookmarks_type_id);
	}
	return bookmarks_type_id__volatile;
}


static void
_vala_bookmarks_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	Bookmarks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOKMARKS, Bookmarks);
	switch (property_id) {
		case BOOKMARKS_SCHEMA_PATH_PROPERTY:
		g_value_set_string (value, bookmarks_get_schema_path (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_bookmarks_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	Bookmarks * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOKMARKS, Bookmarks);
	switch (property_id) {
		case BOOKMARKS_SCHEMA_PATH_PROPERTY:
		bookmarks_set_schema_path (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static inline gpointer
bookmark_get_instance_private (Bookmark* self)
{
	return G_STRUCT_MEMBER_P (self, Bookmark_private_offset);
}


Bookmark*
bookmark_construct (GType object_type,
                    const gchar* bookmark_name)
{
	Bookmark * self = NULL;
	GtkLabel* _tmp0_;
	GVariant* variant = NULL;
	GVariant* _tmp1_;
	GtkButton* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	g_return_val_if_fail (bookmark_name != NULL, NULL);
	self = (Bookmark*) g_object_new (object_type, NULL);
	_tmp0_ = self->priv->bookmark_label;
	gtk_label_set_label (_tmp0_, bookmark_name);
	_tmp1_ = g_variant_new_string (bookmark_name);
	g_variant_ref_sink (_tmp1_);
	variant = _tmp1_;
	_tmp2_ = self->priv->destroy_button;
	_tmp3_ = g_variant_print (variant, FALSE);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat ("bookmarks.unbookmark(", _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp6_, ")", NULL);
	_tmp8_ = _tmp7_;
	gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp2_, _tmp8_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_variant_unref0 (variant);
	return self;
}


Bookmark*
bookmark_new (const gchar* bookmark_name)
{
	return bookmark_construct (TYPE_BOOKMARK, bookmark_name);
}


static void
bookmark_class_init (BookmarkClass * klass)
{
	bookmark_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Bookmark_private_offset);
	G_OBJECT_CLASS (klass)->finalize = bookmark_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/bookmark.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bookmark_label", FALSE, Bookmark_private_offset + G_STRUCT_OFFSET (BookmarkPrivate, bookmark_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "destroy_button", FALSE, Bookmark_private_offset + G_STRUCT_OFFSET (BookmarkPrivate, destroy_button));
}


static void
bookmark_instance_init (Bookmark * self)
{
	self->priv = bookmark_get_instance_private (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void
bookmark_finalize (GObject * obj)
{
	Bookmark * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOKMARK, Bookmark);
	_g_object_unref0 (self->priv->bookmark_label);
	_g_object_unref0 (self->priv->destroy_button);
	G_OBJECT_CLASS (bookmark_parent_class)->finalize (obj);
}


GType
bookmark_get_type (void)
{
	static volatile gsize bookmark_type_id__volatile = 0;
	if (g_once_init_enter (&bookmark_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BookmarkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bookmark_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bookmark), 0, (GInstanceInitFunc) bookmark_instance_init, NULL };
		GType bookmark_type_id;
		bookmark_type_id = g_type_register_static (gtk_list_box_row_get_type (), "Bookmark", &g_define_type_info, 0);
		Bookmark_private_offset = g_type_add_instance_private (bookmark_type_id, sizeof (BookmarkPrivate));
		g_once_init_leave (&bookmark_type_id__volatile, bookmark_type_id);
	}
	return bookmark_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



