/* delayed-setting-view.c generated by valac 0.41.91, the Vala compiler
 * generated from delayed-setting-view.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <https://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_DELAYED_SETTING_VIEW (delayed_setting_view_get_type ())
#define DELAYED_SETTING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DELAYED_SETTING_VIEW, DelayedSettingView))
#define DELAYED_SETTING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DELAYED_SETTING_VIEW, DelayedSettingViewClass))
#define IS_DELAYED_SETTING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DELAYED_SETTING_VIEW))
#define IS_DELAYED_SETTING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DELAYED_SETTING_VIEW))
#define DELAYED_SETTING_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DELAYED_SETTING_VIEW, DelayedSettingViewClass))

typedef struct _DelayedSettingView DelayedSettingView;
typedef struct _DelayedSettingViewClass DelayedSettingViewClass;
typedef struct _DelayedSettingViewPrivate DelayedSettingViewPrivate;
enum  {
	DELAYED_SETTING_VIEW_0_PROPERTY,
	DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY,
	DELAYED_SETTING_VIEW_CONTEXT_PROPERTY,
	DELAYED_SETTING_VIEW_NUM_PROPERTIES
};
static GParamSpec* delayed_setting_view_properties[DELAYED_SETTING_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _DelayedSettingView {
	GtkGrid parent_instance;
	DelayedSettingViewPrivate * priv;
};

struct _DelayedSettingViewClass {
	GtkGridClass parent_class;
};

struct _DelayedSettingViewPrivate {
	GtkLabel* key_name_label;
	GtkLabel* key_value_label;
	GtkLabel* key_value_default;
	GtkLabel* planned_value_label;
	GtkLabel* planned_value_default;
	GtkButton* cancel_change_button;
	gchar* _full_name;
	gchar* _context;
};


static gint DelayedSettingView_private_offset;
static gpointer delayed_setting_view_parent_class = NULL;

GType delayed_setting_view_get_type (void) G_GNUC_CONST;
DelayedSettingView* delayed_setting_view_new (const gchar* name,
                                              const gchar* _full_name,
                                              const gchar* _context,
                                              gboolean has_schema_and_is_default,
                                              GVariant* key_value,
                                              const gchar* cool_planned_value,
                                              const gchar* cool_default_value);
DelayedSettingView* delayed_setting_view_construct (GType object_type,
                                                    const gchar* name,
                                                    const gchar* _full_name,
                                                    const gchar* _context,
                                                    gboolean has_schema_and_is_default,
                                                    GVariant* key_value,
                                                    const gchar* cool_planned_value,
                                                    const gchar* cool_default_value);
const gchar* delayed_setting_view_get_full_name (DelayedSettingView* self);
void delayed_setting_view_update_dconf_key_current_value (DelayedSettingView* self,
                                                          GVariant* key_value_or_null);
static void delayed_setting_view_update_dconf_key_planned_value (DelayedSettingView* self,
                                                          const gchar* cool_planned_value);
void delayed_setting_view_update_gsettings_key_current_value (DelayedSettingView* self,
                                                              GVariant* key_value,
                                                              gboolean is_default);
static void delayed_setting_view_update_gsettings_key_planned_value (DelayedSettingView* self,
                                                              const gchar* cool_planned_value,
                                                              const gchar* cool_default_value);
gchar* key_cool_text_value_from_variant (GVariant* variant);
static void delayed_setting_view_set_full_name (DelayedSettingView* self,
                                         const gchar* value);
const gchar* delayed_setting_view_get_context (DelayedSettingView* self);
static void delayed_setting_view_set_context (DelayedSettingView* self,
                                       const gchar* value);
static void delayed_setting_view_finalize (GObject * obj);
static void _vala_delayed_setting_view_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_delayed_setting_view_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);


static inline gpointer
delayed_setting_view_get_instance_private (DelayedSettingView* self)
{
	return G_STRUCT_MEMBER_P (self, DelayedSettingView_private_offset);
}


DelayedSettingView*
delayed_setting_view_construct (GType object_type,
                                const gchar* name,
                                const gchar* _full_name,
                                const gchar* _context,
                                gboolean has_schema_and_is_default,
                                GVariant* key_value,
                                const gchar* cool_planned_value,
                                const gchar* cool_default_value)
{
	DelayedSettingView * self = NULL;
	GVariant* variant = NULL;
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GtkLabel* _tmp2_;
	GtkButton* _tmp3_;
	GVariant* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (_full_name != NULL, NULL);
	g_return_val_if_fail (_context != NULL, NULL);
	g_return_val_if_fail (key_value != NULL, NULL);
	self = (DelayedSettingView*) g_object_new (object_type, "full-name", _full_name, "context", _context, NULL);
	_tmp0_ = self->priv->_full_name;
	_tmp1_ = g_variant_new_string (_tmp0_);
	g_variant_ref_sink (_tmp1_);
	variant = _tmp1_;
	_tmp2_ = self->priv->key_name_label;
	gtk_label_set_label (_tmp2_, name);
	_tmp3_ = self->priv->cancel_change_button;
	_tmp4_ = variant;
	_tmp5_ = g_variant_print (_tmp4_, FALSE);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat ("ui.dismiss-change(", _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (_tmp8_, ")", NULL);
	_tmp10_ = _tmp9_;
	gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp3_, _tmp10_);
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	if (cool_default_value == NULL) {
		delayed_setting_view_update_dconf_key_current_value (self, key_value);
		delayed_setting_view_update_dconf_key_planned_value (self, cool_planned_value);
	} else {
		delayed_setting_view_update_gsettings_key_current_value (self, key_value, has_schema_and_is_default);
		delayed_setting_view_update_gsettings_key_planned_value (self, cool_planned_value, (const gchar*) cool_default_value);
	}
	_g_variant_unref0 (variant);
	return self;
}


DelayedSettingView*
delayed_setting_view_new (const gchar* name,
                          const gchar* _full_name,
                          const gchar* _context,
                          gboolean has_schema_and_is_default,
                          GVariant* key_value,
                          const gchar* cool_planned_value,
                          const gchar* cool_default_value)
{
	return delayed_setting_view_construct (TYPE_DELAYED_SETTING_VIEW, name, _full_name, _context, has_schema_and_is_default, key_value, cool_planned_value, cool_default_value);
}


static void
delayed_setting_view_update_gsettings_key_planned_value (DelayedSettingView* self,
                                                         const gchar* cool_planned_value,
                                                         const gchar* cool_default_value)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (cool_default_value != NULL);
	if (cool_planned_value == NULL) {
		GtkLabel* _tmp0_;
		GtkLabel* _tmp1_;
		GtkLabel* _tmp2_;
		_tmp0_ = self->priv->planned_value_label;
		gtk_label_set_label (_tmp0_, cool_default_value);
		_tmp1_ = self->priv->planned_value_default;
		gtk_label_set_label (_tmp1_, _ ("Default value"));
		_tmp2_ = self->priv->planned_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
	} else {
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
		_tmp3_ = self->priv->planned_value_label;
		gtk_label_set_label (_tmp3_, (const gchar*) cool_planned_value);
		_tmp4_ = self->priv->planned_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
	}
}


static void
delayed_setting_view_update_dconf_key_planned_value (DelayedSettingView* self,
                                                     const gchar* cool_planned_value)
{
	g_return_if_fail (self != NULL);
	if (cool_planned_value == NULL) {
		GtkLabel* _tmp0_;
		GtkLabel* _tmp1_;
		GtkLabel* _tmp2_;
		_tmp0_ = self->priv->planned_value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
		_tmp1_ = self->priv->planned_value_default;
		gtk_label_set_label (_tmp1_, _ ("Key erased."));
		_tmp2_ = self->priv->planned_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
	} else {
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
		GtkLabel* _tmp5_;
		_tmp3_ = self->priv->planned_value_label;
		gtk_label_set_label (_tmp3_, (const gchar*) cool_planned_value);
		_tmp4_ = self->priv->planned_value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
		_tmp5_ = self->priv->planned_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
	}
}


void
delayed_setting_view_update_gsettings_key_current_value (DelayedSettingView* self,
                                                         GVariant* key_value,
                                                         gboolean is_default)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key_value != NULL);
	_tmp0_ = self->priv->key_value_label;
	_tmp1_ = key_cool_text_value_from_variant (key_value);
	_tmp2_ = _tmp1_;
	gtk_label_set_label (_tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
	if (is_default) {
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
		_tmp3_ = self->priv->key_value_default;
		gtk_label_set_label (_tmp3_, _ ("Default value"));
		_tmp4_ = self->priv->key_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
	} else {
		GtkLabel* _tmp5_;
		_tmp5_ = self->priv->key_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
	}
}


void
delayed_setting_view_update_dconf_key_current_value (DelayedSettingView* self,
                                                     GVariant* key_value_or_null)
{
	g_return_if_fail (self != NULL);
	if (key_value_or_null == NULL) {
		GtkLabel* _tmp0_;
		GtkLabel* _tmp1_;
		GtkLabel* _tmp2_;
		_tmp0_ = self->priv->key_value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
		_tmp1_ = self->priv->key_value_default;
		gtk_label_set_label (_tmp1_, _ ("Key erased"));
		_tmp2_ = self->priv->key_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
	} else {
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GtkLabel* _tmp7_;
		_tmp3_ = self->priv->key_value_default;
		gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
		_tmp4_ = self->priv->key_value_label;
		_tmp5_ = key_cool_text_value_from_variant ((GVariant*) key_value_or_null);
		_tmp6_ = _tmp5_;
		gtk_label_set_label (_tmp4_, _tmp6_);
		_g_free0 (_tmp6_);
		_tmp7_ = self->priv->key_value_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, TRUE);
	}
}


const gchar*
delayed_setting_view_get_full_name (DelayedSettingView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_full_name;
	result = _tmp0_;
	return result;
}


static void
delayed_setting_view_set_full_name (DelayedSettingView* self,
                                    const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, delayed_setting_view_get_full_name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_full_name);
		self->priv->_full_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, delayed_setting_view_properties[DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY]);
	}
}


const gchar*
delayed_setting_view_get_context (DelayedSettingView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_context;
	result = _tmp0_;
	return result;
}


static void
delayed_setting_view_set_context (DelayedSettingView* self,
                                  const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, delayed_setting_view_get_context (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_context);
		self->priv->_context = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, delayed_setting_view_properties[DELAYED_SETTING_VIEW_CONTEXT_PROPERTY]);
	}
}


static void
delayed_setting_view_class_init (DelayedSettingViewClass * klass)
{
	delayed_setting_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DelayedSettingView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_delayed_setting_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_delayed_setting_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = delayed_setting_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY, delayed_setting_view_properties[DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY] = g_param_spec_string ("full-name", "full-name", "full-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DELAYED_SETTING_VIEW_CONTEXT_PROPERTY, delayed_setting_view_properties[DELAYED_SETTING_VIEW_CONTEXT_PROPERTY] = g_param_spec_string ("context", "context", "context", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/delayed-setting-view.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "key_name_label", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, key_name_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "key_value_label", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, key_value_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "key_value_default", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, key_value_default));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "planned_value_label", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, planned_value_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "planned_value_default", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, planned_value_default));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cancel_change_button", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, cancel_change_button));
}


static void
delayed_setting_view_instance_init (DelayedSettingView * self)
{
	self->priv = delayed_setting_view_get_instance_private (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void
delayed_setting_view_finalize (GObject * obj)
{
	DelayedSettingView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DELAYED_SETTING_VIEW, DelayedSettingView);
	_g_object_unref0 (self->priv->key_name_label);
	_g_object_unref0 (self->priv->key_value_label);
	_g_object_unref0 (self->priv->key_value_default);
	_g_object_unref0 (self->priv->planned_value_label);
	_g_object_unref0 (self->priv->planned_value_default);
	_g_object_unref0 (self->priv->cancel_change_button);
	_g_free0 (self->priv->_full_name);
	_g_free0 (self->priv->_context);
	G_OBJECT_CLASS (delayed_setting_view_parent_class)->finalize (obj);
}


GType
delayed_setting_view_get_type (void)
{
	static volatile gsize delayed_setting_view_type_id__volatile = 0;
	if (g_once_init_enter (&delayed_setting_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DelayedSettingViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) delayed_setting_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DelayedSettingView), 0, (GInstanceInitFunc) delayed_setting_view_instance_init, NULL };
		GType delayed_setting_view_type_id;
		delayed_setting_view_type_id = g_type_register_static (gtk_grid_get_type (), "DelayedSettingView", &g_define_type_info, 0);
		DelayedSettingView_private_offset = g_type_add_instance_private (delayed_setting_view_type_id, sizeof (DelayedSettingViewPrivate));
		g_once_init_leave (&delayed_setting_view_type_id__volatile, delayed_setting_view_type_id);
	}
	return delayed_setting_view_type_id__volatile;
}


static void
_vala_delayed_setting_view_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	DelayedSettingView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DELAYED_SETTING_VIEW, DelayedSettingView);
	switch (property_id) {
		case DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY:
		g_value_set_string (value, delayed_setting_view_get_full_name (self));
		break;
		case DELAYED_SETTING_VIEW_CONTEXT_PROPERTY:
		g_value_set_string (value, delayed_setting_view_get_context (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_delayed_setting_view_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	DelayedSettingView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DELAYED_SETTING_VIEW, DelayedSettingView);
	switch (property_id) {
		case DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY:
		delayed_setting_view_set_full_name (self, g_value_get_string (value));
		break;
		case DELAYED_SETTING_VIEW_CONTEXT_PROPERTY:
		delayed_setting_view_set_context (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



